#pragma once

#include "Orts.h"

class MemoryObject
{
public:
    virtual ~MemoryObject();  // L2CacheD 0x00401B40

    virtual long AddRef(const char* file, int, ORTs workType);                    // L2CacheD 0x0042A5A0
    virtual void Release(const char* file, int line, ORTs nWorkType, bool flag);  // L2CacheD 0x00485130
    virtual long RefCount() const;                                                // L2CacheD 0x00401AB0

    virtual bool vfunc10() const;   // L2CacheD 0x00401A90
    virtual bool IsObject() const;  // L2CacheD 0x00401A90
    virtual bool IsUser() const;    // L2CacheD 0x00401AA0
    virtual bool IsItem() const;    // L2CacheD 0x00401A90

protected:
    MemoryObject();                  // L2CacheD 0x004850A0
    void ReportOrt(int a2, int a3);  // L2CacheD 0x00485100

    void setInTimer(bool isInTimer);
    bool inTimer() const;

protected:
    static long s_refCountSlots;  // 0x02684578

private:
    static void operator delete(void* ptr);  // inlined inside deleting destructor

private:
    static long s_instances;  // L2CacheD 0x02684B30
    static long s_nAlloc;     // L2CacheD 0x02684B34

protected:
    volatile long m_nRefCount;
    long m_identity;

private:
    bool m_inTimer;
};
