#pragma once

#include "CIOObject.h"

class CIOBuffer;

class CIOSocket : public CIOObject
{
public:
    ~CIOSocket();  // L2CacheD 0x00480B60

    void OnIOCallback(BOOL bSuccess, DWORD dwTransferred, LPOVERLAPPED lpOverlapped) override;  // L2CacheD 0x00481540
    void Release(const char* file, int line, ORTs nWorkType, bool flag) override;               // L2CacheD 0x004801E0

    void Read(size_t dwLeft);       // L2CacheD 0x00480C30
    void Write(CIOBuffer* buffer);  // L2CacheD 0x00481000

    void Close();       // L2CacheD 0x0047F6A0
    void Initialize();  // L2CacheD 0x0047F920

    int pendingWrite() const;

protected:
    CIOSocket(SOCKET socket);  // L2CacheD 0x00480310

    virtual void OnCreate();  // L2CacheD 0x0047F760
    virtual void OnClose();   // L2CacheD 0x0047F670
    virtual void OnRead() = 0;

    void ReadCallback(DWORD dwTransferred);   // L2CacheD 0x0047F7D0
    void WriteCallback(DWORD dwTransferred);  // L2CacheD 0x00480E40

private:
    static void operator delete(void* ptr);  // inlined inside deleting destructor L2CacheD 0x00481500

protected:
    SOCKET m_hSocket;
    int m_nPendingWrite;
    CIOCriticalSection m_lock;
    OVERLAPPED m_overlappedRead;
    OVERLAPPED m_overlappedWrite;
    CIOBuffer* m_pReadBuf;
    CIOBuffer* m_pFirstBuf;
    CIOBuffer* m_pLastBuf;

private:
    static volatile LONG s_pendingWriteBytes;  // L2CacheD 0x02684634
    static long s_nAlloc;                      // L2CacheD 0x02684924
};
