#pragma once

#include "network/CIOSocket.h"
#include "network/SocketStatus.h"

class CLogSocket : public CIOSocket
{
public:
    typedef bool (*PacketHandler)(CIOSocket*, const uint8_t*);

public:
    CLogSocket(SOCKET socket, const PacketHandler* packetHandlers);  // L2CacheD 0x00484820
    ~CLogSocket();                                                   // L2CacheD 0x004848B0

    static void* operator new(size_t size);  // L2CacheD 0x004843B0
    static void operator delete(void* ptr);  // L2CacheD 0x00484400

    void Release(const char* file, int line, ORTs nWorkType, bool flag) override;  // L2CacheD 0x00484A50
    void Send(const char* format, ...);                                            // L2CacheD 0x00484950

public:
    static const int HANDLERS_NUMBER = 3;
    static const PacketHandler s_packetHandlers[HANDLERS_NUMBER];  // L2CacheD 0x004F16AC

protected:
    void OnClose();  // L2CacheD 0x004848C0
    void OnRead();   // L2CacheD 0x00484BC0

private:
    static bool packet0_SendMsg(CIOSocket* socket, const uint8_t* packet);      // L2CacheD 0x004846D0
    static bool packet1_CheckStatus(CIOSocket* socket, const uint8_t* packet);  // L2CacheD 0x00484700
    static bool packet2_TestPacket(CIOSocket* socket, const uint8_t* packet);   // L2CacheD 0x004847F0

private:
    static long s_nAlloc;  // L2CacheD 0x02684B28

    int m_socket;
    int field_2;
    const PacketHandler* m_packetHandlers;
    SocketStatus m_status;
    int m_packetSize;
};
