#pragma once

#include "CIOObject.h"

static const int CIO_DEADLOCK_CHECKER_INTERVAL = 5 * 1000;

class CIODeadlockChecker : public CIOObject
{
public:
    CIODeadlockChecker();   // L2CacheD 0x0047FF20
    ~CIODeadlockChecker();  // L2CacheD 0x00480980

    static void operator delete(void* ptr);  // inlined inside 0x00480980

    void Release(const char* file, int line, ORTs nWorkType, bool flag) override;  // L2CacheD 0x0047FF80

    void Init();  // inlined

    long lastTick() const;

protected:
    void TimerExpired(int id);  // L2CacheD 0x00482A10

private:
    static long s_nAlloc;  // L2CacheD 0x02684920

    long m_nLastTick;
};

extern CIODeadlockChecker g_deadlock_checker;  // L2CacheD 0x026846E4
