#include "threads/CThreadManager.h"

#include "threads/ThreadLocalStorage.h"

HANDLE CThreadManager::s_threads[ThreadIndex_MaxCount];  // L2CacheD 0x021E6F50
uint32_t CThreadManager::s_IOThreadNumber;               // L2CacheD 0x021E6FA4

// L2CacheD 0x0045B2B0
void CThreadManager::SetThisThreadAsMainThread()
{
    tls::SetCurrentThreadIndex(ThreadIndex_Main);
}

// L2CacheD 0x0045B2D0
bool CThreadManager::isMainThread()
{
    uint32_t threadIndex = tls::GetCurrentThreadIndex();
    return threadIndex == ThreadIndex_Main;
}

// L2CacheD 0x0045B2F0
bool CThreadManager::isListenThread()
{
    uint32_t threadIndex = tls::GetCurrentThreadIndex();
    return threadIndex == ThreadIndex_ListenThread;
}

// L2CacheD 0x0045B330
void CThreadManager::RegisterThisThread(ThreadIndices threadIndex)
{
    tls::SetCurrentThreadIndex(threadIndex);
}

// L2CacheD 0x0045B310
uint32_t CThreadManager::GetIOThreadNumber()
{
    return CThreadManager::s_IOThreadNumber;
}

// L2CacheD 0x0045B320
void CThreadManager::SetIOThreadNumber(int maxIOThreadNumber)
{
    CThreadManager::s_IOThreadNumber = maxIOThreadNumber;
}

// L2CacheD 0x0045B350
void CThreadManager::SetThread(ThreadIndices index, HANDLE thread)
{
    CThreadManager::s_threads[index] = thread;
}

// L2CacheD 0x0045B360
HANDLE CThreadManager::GetThread(ThreadIndices index)
{
    return CThreadManager::s_threads[index];
}

// L2CacheD 0x0047F3A0
uint32_t CThreadManager::GetMaxIOThreadNumber()
{
    // return 16; FIXED

    SYSTEM_INFO systemInfo;
    ::GetSystemInfo(&systemInfo);
    uint32_t coreBasedMax = 2 * systemInfo.dwNumberOfProcessors;
    const uint32_t IO_THREAD_MAX = 16;
    return min(coreBasedMax, IO_THREAD_MAX);
}
