#pragma once

#include "threads/ThreadIndices.h"

#include <windows.h>

#include <vector>
#include <utils/cstdint_support.h>

class CIOObject;

namespace Threads
{

// Main thread loop
void MessageLoop_common(HACCEL hAccTable);   // L2CacheD 0x00409D40
void MessageLoop_mailing(HACCEL hAccTable);  // L2CacheD 0x00409DE0

// CliLog thread
uint32_t __stdcall CliLogThread(void*);  // L2CacheD 0x00484130
void CliLogThread_common();              // L2CacheD 0x004836A0
void CliLogThread_mailing();             // L2CacheD 0x00483610

// L2CacheD server thread
uint32_t __stdcall CacheDListeningThread(void* param);  // L2CacheD 0x0040A9B0
void CacheDListeningThread_common();                    // L2CacheD 0x0040A7D0
void CacheDListeningThread_mailing();                   // L2CacheD 0x0040A920

// Performance monitor
uint32_t __stdcall PerfMonitorThread(void*);  // L2CacheD 0x0040A6B0
void PerfMonitorThread_mailing();             // L2CacheD 0x0040A610
void PerfMonitorThread_common();              // L2CacheD 0x0040A6A0
extern HANDLE PerfMonitor_s_thread;           // L2CacheD 0x004F28B0

// IO thread
void CreateIOThread(uint32_t maxIOThread);         // L2CacheD 0x00481DF0
void WaitThread();                                 // L2CacheD 0x004818E0
uint32_t __stdcall IOThread(void* threadIndex);    // L2CacheD 0x00481D30
void IOThread_common(ThreadIndices threadIndex);   // L2CacheD 0x00481AE0
void IOThread_mailing(ThreadIndices threadIndex);  // L2CacheD 0x00481C90

extern HANDLE s_timer;                     // L2CacheD 0x02684630
extern bool g_bTerminating;                // L2CacheD 0x02684628
extern std::vector<HANDLE> g_vHandle;      // L2CacheD 0x026846D4
extern std::vector<CIOObject*> g_vObject;  // L2CacheD 0x02684928

}  // namespace Threads
