#pragma once

#include <Pdh.h>

#include <utils/cstdint_support.h>

class PerfMonitor
{
public:
    PerfMonitor();   // L2CacheD 0x00485260
    ~PerfMonitor();  // L2CacheD 0x0049D9E0
    bool Init();     // L2CacheD 0x004852A0
#ifdef L2LOGD
    bool PerfMonitor::Reload();  // L2LogD 0x0040E070
#endif

    static void Job();  // L2CacheD 0x0040A1C0

private:
    bool CheckPerformance();  // L2CacheD 0x004856E0
    void Clean();             // L2CacheD 0x004856A0

private:
    struct CounterElement;

    CounterElement* m_counterElements;
    PDH_HCOUNTER* m_pdhCounters;
    PDH_HQUERY m_pdhQuery;
    int m_unused;
    PDH_FMT_COUNTERVALUE m_counterValue;
    bool m_checkPerformance;
    bool m_memUsage;
    int m_interval;
    int m_pdhCountersNumber;
    bool m_initialized;
    time_t m_startTime;
    int m_processId;
    int m_memoryLoad;
    int m_availablePhysMemory;
    int m_totalPhysMemory;
    int m_physicallyUsedMemory;
    bool m_firstDataQuery;
};

extern PerfMonitor g_perfMonitor;  // L2CacheD 0x02684B38
