#pragma once

#include "ui/CLog.h"

#include <windows.h>

class CExceptionInit
{
public:
    CExceptionInit();   // L2CacheD 0x004109D0
    ~CExceptionInit();  // L2CacheD 0x0049D7E0

    static void LogException(const wchar_t* format, ...);  // L2CacheD 0x00410AE0
    static LONG ExceptionFilter(void* ex)
    {
        return ExceptionFilter((_EXCEPTION_POINTERS*)(ex));
    }
    static int ExceptionFilter(EXCEPTION_POINTERS* ex);  // L2CacheD 0x00410CC0
    static void SendExceptionLog(bool fatal);            // L2CacheD 0x00410D10

public:
    static wchar_t s_logPath[MAX_PATH];  // L2CacheD 0x00AD5610
    static time_t s_startTime;           // L2CacheD 0x00AEA158

private:
    static LONG WINAPI RecordExceptionInfo(struct _EXCEPTION_POINTERS* exceptionInfo);                                       // L2CacheD 0x004108A0
    static void RestoreTopLevelFilter();                                                                                     // L2CacheD 0x004109B0
    static void InstallTopLevelFilter();                                                                                     // L2CacheD 0x00410990
    static bool SendMail(const char* ipAddress, const char* mailServer, const char* mailFrom, const wchar_t* errorLogPath);  // L2CacheD 0x0040FBE0
    static bool SendFile(SOCKET socket, const wchar_t* fileToSend);                                                          // L2CacheD 0x0040FB10

private:
    static LPTOP_LEVEL_EXCEPTION_FILTER s_oldFilter;  // L2CacheD 0x00AEA050
    static CRITICAL_SECTION s_lock;                   // L2CacheD 0x00AD5818
    static int s_errorReported;                       // L2CacheD 0x00AEA20C
};

extern CExceptionInit g_exeptionHalder;  // L2CacheD 0x00AEA210

#define _BEFORE                                                                                                                                                                                                                                                                                                                \
    __try                                                                                                                                                                                                                                                                                                                      \
    {

#define _AFTER_FIN                                                                                                                                                                                                                                                                                                             \
    }                                                                                                                                                                                                                                                                                                                          \
    __except (CExceptionInit::ExceptionFilter(_exception_info()))                                                                                                                                                                                                                                                              \
    {                                                                                                                                                                                                                                                                                                                          \
        CExceptionInit::LogException(L"*%S:%d(%S) exception\n", __FILE__, __LINE__, __TIMESTAMP__);                                                                                                                                                                                                                            \
        g_winlog.FlushLogFile();                                                                                                                                                                                                                                                                                               \
        CExceptionInit::SendExceptionLog(true);                                                                                                                                                                                                                                                                                \
    }
