#pragma once

#include "MemoryObject.h"
#include "threads/CIOCriticalSection.h"

#include <windows.h>

class CIOObject : public MemoryObject
{
public:
    ~CIOObject();  // 0x0040A450

    virtual void OnTimer(int id);                                                           // 0x00409260
    virtual void OnTimerCallback(int id);                                                   // 0x004087B0
    virtual void OnWaitCallback();                                                          // 0x00409270
    virtual void OnIOCallback(BOOL success, DWORD transferred, LPOVERLAPPED lpOverlapped);  // 0x00408840
    virtual BOOL PostObject(DWORD id);                                                      // 0x00409280

    static bool SetShortTimeStamp(long* pTimeVar, DWORD nAdditional);  // 0x004088C0
    static void TimerDispatch();                                       // 0x0040A9F0

protected:
    CIOObject();

    virtual void TimerExpired(int id);

    bool RegisterWait(HANDLE handle);          // 0x0040B810
    bool AddTimer(unsigned int time, int id);  // 0x0040BA70

private:
    static CIOCriticalSection g_globalLockTimer;  // 0x01BD3C18
    static volatile LONG s_objectInTimer;         // 0x01BD3C0C
};
