#pragma once

#include "Orts.h"

class MemoryObject
{
public:
    virtual ~MemoryObject();  // 0x00409210

    virtual long AddRef(const char*, int, ORTs workType);                         // 0x00408980
    virtual void Release(const char* file, int line, ORTs nWorkType, bool flag);  // 0x0040DB20
    virtual long RefCount() const;                                                // 0x00409200

    virtual bool vfunc10() const;   // 0x00424CC8
    virtual bool IsObject() const;  // 0x00424CD0
    virtual bool IsUser() const;    // 0x004091F0
    virtual bool IsItem() const;    // 0x00424CD8

protected:
    MemoryObject();  // 0x0040DAB0

    void ReportOrt(int a2, int a3);  // 0x0040DB00

    void setInTimer(bool isInTimer);
    bool inTimer() const;

protected:
    static long s_refCountSlots;  // 0x01BD3B60

private:
    static void operator delete(void* ptr);  // inlined inside deleting destructor

private:
    static long s_instances;  // 0x01BD4FC4
    static long s_nAlloc;     // 0x01BD4FC8

protected:
    volatile long m_nRefCount;
    long m_identity;

private:
    bool m_inTimer;
};
