#pragma once

#include "threads/CIOCriticalSection.h"
#include "db/Pools.h"

#include <windows.h>
#include <Sqltypes.h>

#include "utils/cstdint_support.h"

struct SqlConnection;

class DBConn
{
public:
    DBConn();   // 0x00401000
    ~DBConn();  // 0x004010F0

    static void Init();  // 0x00402340

    bool Fetch();                                          // 0x00401FC0
    void Bind(wchar_t* value, int length);                 // 0x00402250
    void BindNullable(int* value, SQLINTEGER* indicator);  // 0x004022F0
    void ResetHtmt();                                      // 0x004022A0
    bool Execute(const wchar_t* format, ...);              // 0x00402450

private:
    static void AllocSQLPool();                                                                // 0x00401250
    static void AllocSQLPool2();                                                               // 0x00401470
    static void AllocSQLPool3();                                                               // 0x004016C0
    static void Error(SQLSMALLINT handleType, SQLHANDLE handle, const wchar_t* query);         // 0x00402120
    static bool Login();                                                                       // 0x00401BD0
    static bool LoadStrFromReg(wchar_t* str, const wchar_t* keyStr, const wchar_t* regEntry);  // 0x004060B0
    static void SaveStrToReg(wchar_t* str, const wchar_t* keyStr, const wchar_t* regEntry);    // 0x004061C0

    static BOOL CALLBACK loginDlgProc(HWND hDlg, UINT msgType, WPARAM wparam, LPARAM a4);     // 0x00401910
    static BOOL CALLBACK loginBBSDlgProc(HWND hDlg, UINT msgType, WPARAM wparam, LPARAM a4);  // 0x00401A70

private:
    static int s_dbConnectionNum1;             // 0x0042D7D4
    static int s_dbConnectionNum2;             // 0x019D7DF4 // TODO: #2 is for BBS
    static int s_dbConnectionNum3;             // 0x019D7E20
    static SqlConnection* s_sqlConnections1;   // 0x0042E7E8
    static SqlConnection* s_sqlConnections2;   // 0x0042E7E4
    static SqlConnection* s_sqlConnections3;   // 0x0042E7E0
    static wchar_t s_connStrBBS[256];          // 0x0042E7F0
    static wchar_t s_connStr[256];             // 0x0042E9F0
    static SQLHANDLE s_sqlEnvHandle;           // 0x0042EBF0
    static SqlConnection* s_connectionsHead1;  // 0x0042EBF4
    static SqlConnection* s_connectionsHead2;  // 0x0042EBF8
    static SqlConnection* s_connectionsHead3;  // 0x0042EBFC
    static CIOCriticalSection s_lock1;         // 0x0042EC00
    static CIOCriticalSection s_lock2;         // 0x0042EC1C

private:
    SQLHSTMT m_sqlHandler;
    int m_currentCollumn;
    SqlConnection* m_sqlConnection;
    Pools m_poolIndex;

    static const int QUERY_MAX_LEN = 512;
    wchar_t m_lastQuery[QUERY_MAX_LEN];
};
