#include "network/CIOBufferPool.h"

#include "network/CIOBuffer.h"
#include "threads/CThreadManager.h"

CIOBufferPool* g_IOBufferPools[ThreadIndex_MaxCount];  // 0x01BD3BD4

// 0x00409160
CIOBufferPool::CIOBufferPool(int size)
    : m_buffers(new CIOBuffer[size])
    , m_bufferIndexes(new CIOBuffer*[size])
    , m_allocIndex(0)
    , m_freeIndex(size)
    , m_freeSlots(size)
    , m_poolSize(size)
{
    for (int i = 0; i < size; ++i)
    {
        CIOBuffer* buffer = &m_buffers[i];
        m_bufferIndexes[i] = buffer;
    }
}

// 0x004092F0
int CIOBufferPool::getFreeSlotsNumberFromAllPools()
{
    int freeSlots = 0;
    for (uint32_t i = 0; i < CThreadManager::GetIOThreadNumber(); ++i)
    {
        CIOBufferPool* pool = g_IOBufferPools[i];
        if (pool != NULL)
        {
            freeSlots += pool->m_freeSlots;
        }
    }

    return freeSlots;
}

int CIOBufferPool::getPoolMaxSize() const
{
    return m_poolSize;
}
