#pragma once

#include "CIOObject.h"

class CIOBuffer;

class CIOSocket : public CIOObject
{
public:
    ~CIOSocket();  // 0x00409D10

    void OnIOCallback(BOOL bSuccess, DWORD dwTransferred, LPOVERLAPPED lpOverlapped) override;  // 0x0040A7C0
    void Release(const char* file, int line, ORTs nWorkType, bool flag) override;               // 0x00409540

    void Read(size_t dwLeft);       // 0x00409DD0
    void Write(CIOBuffer* buffer);  // 0x0040A180

    void Close();       // 0x004089C0
    void Initialize();  // 0x00408BF0

protected:
    CIOSocket(SOCKET socket);  // 0x00409670

    virtual void OnCreate();  // 0x00408A70
    virtual void OnClose();   // 0x004089A0
    virtual void OnRead() = 0;

    void ReadCallback(DWORD dwTransferred);   // 0x00408AD0
    void WriteCallback(DWORD dwTransferred);  // 0x00409FC0

private:
    static void operator delete(void* ptr);  // inlined inside deleting destructor 0x0040A780

protected:
    SOCKET m_hSocket;
    int m_nPendingWrite;
    CIOCriticalSection m_lock;
    OVERLAPPED m_overlappedRead;
    OVERLAPPED m_overlappedWrite;
    CIOBuffer* m_pReadBuf;
    CIOBuffer* m_pFirstBuf;
    CIOBuffer* m_pLastBuf;

private:
    static volatile LONG s_pendingWriteBytes;  // 0x01BD3BCC
    static long s_nAlloc;                      // 0x01BD3D7C
};
