#pragma once

#include "CIOObject.h"

static const int CIO_DEADLOCK_CHECKER_INTERVAL = 5 * 1000;

class CIODeadlockChecker : public CIOObject
{
public:
    CIODeadlockChecker();   // 0x004092A0
    ~CIODeadlockChecker();  // 0x00409CD0

    static void operator delete(void* ptr);  // inlined inside 0x00409CD0

    void Release(const char* file, int line, ORTs nWorkType, bool flag) override;  // 0x00409330

    void Init();  // inlined

    long lastTick() const;

protected:
    void TimerExpired(int id) override;  // 0x0040BBB0

private:
    static long s_nAlloc;  // 0x01BD3D78

    long m_nLastTick;
};

extern CIODeadlockChecker g_deadlock_checker;  // 0x01BD3D5C
