#pragma once

#include "threads/ThreadIndices.h"

#include <windows.h>

#include "utils/cstdint_support.h"

class CThreadManager
{
public:
    static void RegisterThisThread(ThreadIndices threadIndex);  // 0x00406050
    static void SetThisThreadAsMainThread();                    // 0x00405FD0
    static bool isMainThread();                                 // 0x00405FF0
    static bool isListenThread();                               // 0x00406010

    static uint32_t GetIOThreadNumber();                        // 0x00406030
    static void SetIOThreadNumber(uint32_t maxIOThreadNumber);  // 0x00406040
    static uint32_t GetMaxIOThreadNumber();                     // 0x004086B0

    static void SetThread(ThreadIndices index, HANDLE threadId);  // 0x00406070
    static HANDLE GetThread(ThreadIndices index);                 // 0x00406080

private:
    static HANDLE s_threads[ThreadIndex_MaxCount];  // 0x019D6934
    static uint32_t s_IOThreadNumber;               // 0x019D6968
};
