#pragma once

#include <Pdh.h>

#include <utils/cstdint_support.h>

class PerfMonitor
{
public:
    PerfMonitor();   // 0x0040DC50
    ~PerfMonitor();  // 0x00420A40
    bool Init();     // 0x0040DC90
    bool Reload();   // 0x0040E070

    static void Job();  // 0x00403D30

private:
    bool CheckPerformance();  // 0x0040E0A0
    void Clean();             // 0x0040E030

private:
    struct CounterElement;

    CounterElement* m_counterElements;
    PDH_HCOUNTER* m_pdhCounters;
    PDH_HQUERY m_pdhQuery;
    int m_unused;
    PDH_FMT_COUNTERVALUE m_counterValue;
    bool m_checkPerformance;
    bool m_memUsage;
    int m_interval;
    int m_pdhCountersNumber;
    bool m_initialized;
    time_t m_startTime;
    int m_processId;
    int m_memoryLoad;
    int m_availablePhysMemory;
    int m_totalPhysMemory;
    int m_physicallyUsedMemory;
    bool m_firstDataQuery;
};

extern PerfMonitor g_perfMonitor;
